"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const generator_1 = require("@babel/generator");
const prettier = require("prettier");
const pkgJson = require('../../../package.json');
const prettierConfig = Object.assign({}, pkgJson.prettier, { parser: 'typescript' });
class Printer {
    constructor() {
        this.printQueue = [];
    }
    print() {
        return this.printQueue
            .reduce((doc, printable) => {
            let str;
            if (typeof printable === 'string') {
                str = doc + printable;
            }
            else {
                const documentPart = generator_1.default(printable).code;
                str = doc + documentPart;
            }
            return prettier.format(str, prettierConfig);
        }, '');
    }
    enqueue(printable) {
        this.printQueue = [
            ...this.printQueue,
            '\n',
            '\n',
            printable
        ];
    }
    printAndClear() {
        const output = this.print();
        this.printQueue = [];
        return output;
    }
}
exports.default = Printer;
//# sourceMappingURL=printer.js.map